// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AO16/16AO16_Linux_2.x.x.x_DN/samples/sbtest/perform.c $
// $Rev: 53282 $
// $Date: 2023-06-28 14:15:26 -0500 (Wed, 28 Jun 2023) $

// 16AO16: Sample Application: source file

#include "main.h"



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int	errs	= 0;

	errs	+= reg_read_test(args->fd);				// AO16_IOCTL_REG_READ
	errs	+= reg_write_test(args->fd);			// AO16_IOCTL_REG_WRITE
	errs	+= reg_mod_test(args->fd);				// AO16_IOCTL_REG_MOD
	errs	+= query_test(args->fd);				// AO16_IOCTL_QUERY
	errs	+= initialize_test(args->fd);			// AO16_IOCTL_INITIALIZE
	errs	+= autocal_test(args->fd);				// AO16_IOCTL_AUTOCAL
	errs	+= autocal_status_test(args->fd);		// AO16_IOCTL_AUTOCAL_STATUS
	errs	+= tx_io_abort_test(args->fd);			// AO16_IOCTL_TX_IO_ABORT
	errs	+= tx_io_mode_test(args->fd);			// AO16_IOCTL_TX_IO_MODE
	errs	+= tx_io_over_data_test(args->fd);		// AO16_IOCTL_TX_IO_OVER_DATA
	errs	+= tx_io_over_frame_test(args->fd);		// AO16_IOCTL_TX_IO_OVER_FRAME
	errs	+= tx_io_timeout_test(args->fd);		// AO16_IOCTL_TX_IO_TIMEOUT

	errs	+= buffer_clear_test(args->fd);			// AO16_IOCTL_BUFFER_CLEAR
	errs	+= buffer_mode_test(args->fd);			// AO16_IOCTL_BUFFER_MODE
	errs	+= buffer_over_data_test(args->fd);		// AO16_IOCTL_BUFFER_OVER_DATA
	errs	+= buffer_over_frame_test(args->fd);	// AO16_IOCTL_BUFFER_OVER_FRAME
	errs	+= buffer_size_test(args->fd);			// AO16_IOCTL_BUFFER_SIZE
	errs	+= buffer_status_test(args->fd);		// AO16_IOCTL_BUFFER_STATUS
	errs	+= burst_enable_test(args->fd);			// AO16_IOCTL_BURST_ENABLE
	errs	+= burst_ready_test(args->fd);			// AO16_IOCTL_BURST_READY
	errs	+= burst_trig_src_test(args->fd);		// AO16_IOCTL_BURST_TRIG_SRC
	errs	+= burst_trigger_test(args->fd);		// AO16_IOCTL_BURST_TRIGGER
	errs	+= cbl_iso_clock_io_test(args->fd);		// AO16_IOCTL_CBL_ISO_CLOCK_IO
	errs	+= cbl_iso_dac_clk_out_test(args->fd);	// AO16_IOCTL_CBL_ISO_DAC_CLK_OUT
	errs	+= cbl_iso_trig_out_test(args->fd);		// AO16_IOCTL_CBL_ISO_TRIG_OUT
	errs	+= cbl_pol_clock_io_test(args->fd);		// AO16_IOCTL_CBL_POL_CLOCK_IO
	errs	+= cbl_pol_dac_clk_out_test(args->fd);	// AO16_IOCTL_CBL_POL_DAC_CLK_OUT
	errs	+= cbl_pol_trig_in_test(args->fd);		// AO16_IOCTL_CBL_POL_TRIG_IN
	errs	+= cbl_pol_trig_out_test(args->fd);		// AO16_IOCTL_CBL_POL_TRIG_OUT
	errs	+= channel_sel_test(args->fd);			// AO16_IOCTL_CHANNEL_SEL
	errs	+= clock_enable_test(args->fd);			// AO16_IOCTL_CLOCK_ENABLE
	errs	+= clock_ready_test(args->fd);			// AO16_IOCTL_CLOCK_READY
	errs	+= clock_ref_src_test(args->fd);		// AO16_IOCTL_CLOCK_REF_SRC
	errs	+= clock_src_test(args->fd);			// AO16_IOCTL_CLOCK_SRC
	errs	+= clock_sw_test(args->fd);				// AO16_IOCTL_CLOCK_SW
	errs	+= data_format_test(args->fd);			// AO16_IOCTL_DATA_FORMAT
	errs	+= ground_sense_test(args->fd);			// AO16_IOCTL_GROUND_SENSE
	errs	+= irq_sel_test(args->fd);				// AO16_IOCTL_IRQ_SEL
	errs	+= load_ready_test(args->fd);			// AO16_IOCTL_LOAD_READY
	errs	+= load_request_test(args->fd);			// AO16_IOCTL_LOAD_REQUEST
	errs	+= nclk_test(args->fd);					// AO16_IOCTL_NCLK
	errs	+= nrate_test(args->fd);				// AO16_IOCTL_NRATE
	errs	+= output_filter_test(args->fd);		// AO16_IOCTL_OUTPUT_FILTER
	errs	+= output_mode_test(args->fd);			// AO16_IOCTL_OUTPUT_MODE
	errs	+= range_test(args->fd);				// AO16_IOCTL_RANGE
	errs	+= wait_event_test(args->fd);			// AO16_IOCTL_WAIT_EVENT
	errs	+= wait_cancel_test(args->fd);			// AO16_IOCTL_WAIT_CANCEL
	errs	+= wait_status_test(args->fd);			// AO16_IOCTL_WAIT_STATUS
	errs	+= watchdog_enable_test(args->fd);		// AO16_IOCTL_WATCHDOG_ENABLE
	errs	+= watchdog_output_test(args->fd);		// AO16_IOCTL_WATCHDOG_OUTPUT
	errs	+= xcvr_test(args->fd);					// AO16_IOCTL_XCVR_TYPE

	return(errs);
}


