// $URL:$
// $Rev:$
// $Date:$

// 16AO16: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	ao16_autocal_status
*
*	Purpose:
*
*		Provide a visual wrapper for the AO16_IOCTL_AUTOCAL_STATUS service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		get		The current setting is recorded here, if not NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int	ao16_autocal_status(int fd, int index, int verbose, s32* get)
{
	char	buf[128];
	int		errs;
	int		ret;
	s32		set;

	if (verbose)
		gsc_label_index("Autocal Status", index);

	ret		= ao16_ioctl(fd, AO16_IOCTL_AUTOCAL_STATUS, &set);
	errs	= ret ? 1 : 0;

	switch (set)
	{
		default:

			errs++;
			sprintf(buf, "INVALID: %ld", (long) set);
			break;

		case AO16_AUTOCAL_STATUS_ACTIVE:

			strcpy(buf, "Active");
			break;

		case AO16_AUTOCAL_STATUS_FAIL:

			strcpy(buf, "Fail");
			break;

		case AO16_AUTOCAL_STATUS_PASS:

			strcpy(buf, "Pass");
			break;
	}

	if (verbose)
		printf("%s  (%s)\n", errs ? "FAIL <---" : "PASS", buf);

	if (get)
		get[0]	= set;

	return(errs);
}


