// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AO16/16AO16_Linux_2.x.x.x_DN/utils/util_channel_sel.c $
// $Rev: 52413 $
// $Date: 2023-01-19 15:50:37 -0600 (Thu, 19 Jan 2023) $

// 16AO16: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	ao16_channel_sel
*
*	Purpose:
*
*		Provide a visual wrapper for the AO16_IOCTL_CHANNEL_SEL service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		set		The setting to apply.
*
*		get		The current setting is recorded here, if not NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ao16_channel_sel(int fd, int index, int verbose, s32 set, s32* get)
{
	int		errs;
	int		ret;

	if (verbose)
		gsc_label_index("Channel Selections", index);

	ret		= ao16_ioctl(fd, AO16_IOCTL_CHANNEL_SEL, &set);
	errs	= ret ? 1 : 0;

	if (verbose)
		printf("%s  (Channels 0x%lX)\n", errs ? "FAIL <---" : "PASS", (long) set);

	if (get)
		get[0]	= set;

	return(errs);
}


